using System;
using System.Net.Sockets;
using System.IO;
using System.Globalization;

namespace GUI
{	
	/// <summary>
	/// Klasse fr die Kommunikation zu
    /// einem Server
	/// </summary>
	
	
	
	public class Connection
	{
		//der Server fr die Verbindung
        private Server server;
		//ein NetworkStram zum Senden
        private NetworkStream toserver;
        //ein StreamReader zum Empfangen
		private StreamReader fromserver;
        //der eingentliche client/socket
		private TcpClient client;
        //wert, ob eine Verbindung besteht
        public Boolean is_connected;


		//Konstruktor mit einem Server als Argument
        public Connection(Server server)
		{
			this.server = server;
		}

        //Methode um mit einem Server eine Verbindung
        //aufzunehmen
		private void connect()    
		{
			//Socket wird aufgebaut
            client = new TcpClient(server.gethost(),server.getport());
			//Streams werden festgelegt
            fromserver = new StreamReader(client.GetStream());
            toserver = client.GetStream();
            //timeout fr das Empfangen
            client.ReceiveTimeout = 2000;
            //Flag, ob Verbindung offen ist auf True setzen
            is_connected = true;
        }

		//Methode um einen String an den Server zu senden
        //die Antwort des Servers wird als String zurckgegeben
        public String receive(String tosend)
		{
			//Verbindung aufbauen
            connect();
            //String mit CRLF versehen
            tosend = tosend + "\r\n";
            //String in ein Byte-Array umwandeln
            Byte[] test = new System.Text.ASCIIEncoding().GetBytes(tosend);
            //das Byte-Array wird zum Server gesendet
            toserver.Write(test,0,test.Length);
            toserver.Flush();
            //Ergebnis vom Server
            String rec = fromserver.ReadLine().ToString();
            close();
            //Rckgabe des empfangenen Strings
            return rec;
		
		}
        //Methode um einen String an den Server zu senden
        //die Antwort des Servers wird in ein MResult umgewandelt
        public MResult receiveResult(String tosend)
        {
            //Verbindungsaufbau
            connect();
            //String mit CRLF senden
            tosend = tosend + "\r\n";
            Byte[] test = new System.Text.ASCIIEncoding().GetBytes(tosend);
            toserver.Write(test, 0, test.Length);
            toserver.Flush();
            //Empfangsergebnis
            String rec = null;
            rec = fromserver.ReadLine();
            //verbindung schlieen
            close();
            //Gltigkeit des Messwerts mit der Voreinstellung
            //"false"
            Boolean valid = false;
            //Hilfsstring fr das Messergebnis
            String res = "";
            //aufteilen des empfangenen Strings in die logischen
            //Teile mit dem Trennzeichen: ;
            String[] array = rec.Split(';');
            //heraussuchen der Informationen aus dem 
            //oben erstellten Array
            for (int i=0; i<array.Length; i++)
            {
                //valid bit vom Messergebnis
                if (array[i].StartsWith("valid"))
                {
                    if (array[i].Substring(6).Equals("1")) valid = true;
                }
                //eigentlicher Messwert
                if (array[i].StartsWith("value"))
                {
                    res=array[i].Substring(6);
                }
            }
            //parsen des Ergebnis-String
            NumberFormatInfo format = new NumberFormatInfo();
            format.NumberDecimalSeparator = ".";
            double result = Double.Parse(res, format);
                                      
            return new MResult(result, valid);
        }
         
        //Verbindung wird beendet
		public void close()
		{
            client.Close();
            is_connected = false;
		}


	}
}
